'基本ﾃﾞｰﾀ仕様の入力
Public Class Diff3DDat0

    Dim KindFmoveb As Integer   'KindFmoveの一時保存変数
    Dim Mstatb As Integer       'Mstatの一時保存変数
    Dim Nmatb As Integer    'Nmatの一時保存変数
    Dim Npointb, Nelemb As Integer  'Npoint,Nelemの一時保存変数
    Dim Nstepb As Integer           'Nstepの保存変数

    Private Sub BoundChange()
        '境界条件の保存変更
        Dim i, j As Integer
        Dim buf(Nstepb) As Single
        For i = 1 To Nstepb
            buf(i) = TimeStep(i)
        Next i
        ReDim TimeStep(Nstep)
        For i = 1 To Nstepb
            TimeStep(i) = buf(i)
        Next i

        If NboundP > 0 Then
            Dim buf2(NboundP, Nstepb) As Single
            For i = 1 To NboundP
                For j = 1 To Nstepb
                    buf2(i, j) = ConcFixP(i, j)
                Next j
            Next i
            ReDim ConcFixP(NboundP, Nstep)
            For i = 1 To NboundP
                For j = 1 To Nstepb
                    ConcFixP(i, j) = buf2(i, j)
                Next j
            Next i
        End If

        If NboundS > 0 Then
            Dim buf3(NboundS, Nstepb) As Single
            For i = 1 To NboundS
                For j = 1 To Nstepb
                    buf3(i, j) = ConcFixS(i, j)
                Next j
            Next i
            ReDim ConcFixS(NboundS, Nstep)
            For i = 1 To NboundS
                For j = 1 To Nstepb
                    ConcFixS(i, j) = buf3(i, j)
                Next j
            Next i
        End If

        If Nflux > 0 Then
            Dim buf4(Nflux, Nstepb) As Single
            For i = 1 To Nflux
                For j = 1 To Nstepb
                    buf4(i, j) = Pnorm(i, j)
                Next j
            Next i
            ReDim Pnorm(Nflux, Nstep)
            For i = 1 To Nflux
                For j = 1 To Nstepb
                    Pnorm(i, j) = buf4(i, j)
                Next j
            Next i
        End If

        If Namb > 0 Then
            Dim buf5(Namb, Nstepb), buf6(Namb, Nstepb) As Single
            For i = 1 To Namb
                For j = 1 To Nstepb
                    buf5(i, j) = Alpha(i, j)
                    buf6(i, j) = ConcAmb(i, j)
                Next j
            Next i
            ReDim Alpha(Namb, Nstep), ConcAmb(Namb, Nstep)
            For i = 1 To Namb
                For j = 1 To Nstepb
                    Alpha(i, j) = buf5(i, j)
                    ConcAmb(i, j) = buf6(i, j)
                Next j
            Next i
        End If

    End Sub

    Private Sub EDatSet()
        '要素ﾃﾞｰﾀの保存変更
        Dim i, j, nmax As Integer
        Dim nbuf1(Nelemb) As Single
        If KindElem = 0 Then
            nmax = 20
        End If
        Dim nbuf2(Nelemb, nmax) As Single
        For i = 1 To Nelemb
            nbuf1(i) = NumMat(i)
            For j = 1 To nmax
                nbuf2(i, j) = NNelem(i, j)
            Next j
        Next i
        ReDim NNelem(Nelem, nmax), NumMat(Nelem)
        For i = 1 To Nelemb
            NumMat(i) = nbuf1(i)
            For j = 1 To nmax
                NNelem(i, j) = nbuf2(i, j)
            Next j
        Next i

    End Sub

    Private Sub IDatSet()
        '初期値データの保存変更
        Dim i As Integer
        Dim buf1(Npointb) As Single
        For i = 1 To Npointb
            buf1(i) = ConcInit(i)
        Next i
        ReDim ConcInit(Npoint)
        For i = 1 To Npointb
            ConcInit(i) = buf1(i)
        Next i
    End Sub

    Private Sub IDatVSet()
        '速度・圧力度の初期値データの保存変更
        Dim i, j As Integer
        Dim buf1(Npointb, 4) As Single
        For i = 1 To Npointb
            For j = 1 To 4
                buf1(i, j) = Vinit(i, j)
            Next j
        Next i
        ReDim Vinit(Npoint, 4)
        For i = 1 To Npointb
            For j = 1 To 4
                Vinit(i, j) = buf1(i, j)
            Next j
        Next i
    End Sub

    Private Sub PDatSet()
        '節点ﾃﾞｰﾀの保存変更
        Dim i As Integer
        Dim xdb(Npointb), ydb(Npointb), zdb(Npointb) As Single
        For i = 1 To Npointb
            xdb(i) = Xdata(i)
            ydb(i) = Ydata(i)
            zdb(i) = Zdata(i)
        Next i
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)
        For i = 1 To Npointb
            Xdata(i) = xdb(i)
            Ydata(i) = ydb(i)
            Zdata(i) = zdb(i)
        Next i

    End Sub

    Private Sub SpecSet()
        '入力ﾃﾞｰﾀ仕様の設定
        Dim aa$

        aa$ = Title$
        Title$ = TextBox1.Text
        If aa$ <> Title$ Then
            KdataChange = 1
        End If
        Npoint = Val(TextBox3.Text)
        If Npoint < 20 Then
            Npoint = 20
        End If
        If Npointb <> Npoint Then
            KdataChange = 1
        End If
        Nelem = Val(TextBox4.Text)
        If Nelem < 1 Then
            Nelem = 1
        End If
        If Nelemb <> Nelem Then
            KdataChange = 1
        End If
        Nmat = Val(TextBox6.Text)
        If Nmat < 1 Then
            Nmat = 1
        End If
        If Nmatb <> Nmat Then
            KdataChange = 1
        End If
        Nstep = Val(TextBox7.Text)
        If Nstepb <> Nstep Then
            KdataChange = 1
        End If

        If Npoint > Npointb Then
            Call PDatSet()  '節点ﾃﾞｰﾀの保存変更
            If KindFmove > 0 Then
                If InitDataV > 0 Then
                    Call IDatVSet()  '速度・圧力の初期値データの保存変更
                End If
            End If
            If InitData > 0 Then
                Call IDatSet()  '初期値データの保存変更
            End If
        End If

        If Nelem > Nelemb Then
            Call EDatSet()  '要素ﾃﾞｰﾀの保存変更
        End If

        If Nmat > Nmatb Then
            Call MDatSet2(Nmatb, Nmat)  '材料ﾃﾞｰﾀの保存変更2
        End If

        If KindFmove > 0 Then
            Nflux = 0
            Namb = 0
        End If
        If Nstep > Nstepb Then
            Call BoundChange()  '境界条件の保存変更
        End If

        If KindFmoveb <> KindFmove Or Mstatb <> Mstat Then
            KdataChange = 1
        End If

        KindFmoveb = KindFlow
        Mstatb = Mstat
        Npointb = Npoint : Nelemb = Nelem : Nmatb = Nmat : Nstepb = Nstep

    End Sub

    Private Sub Diff3DDat0_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ic As Integer
        TextBox1.Text = Title$
        TextBox3.Text = LTrim$(Str$(Npoint))
        TextBox4.Text = LTrim$(Str$(Nelem))

        If KindFmove = 0 Then
            RadioButton1.Checked = True
        Else
            RadioButton2.Checked = True
            If Nmat > 1 Then
                Nmat = 1
            End If
        End If

        ic = 0
        If Mstat = 0 Then
            RadioButton3.Checked = True
        Else
            RadioButton4.Checked = True
            If KindFmove = 0 Then
                ic = 1
            End If
        End If
        If ic = 0 Then
            If Nstep > 1 Then
                Nstep = 1
            End If
        End If

        TextBox6.Text = LTrim$(Str$(Nmat))
        TextBox7.Text = LTrim$(Str$(Nstep))

        Npointb = Npoint : Nelemb = Nelem : Nmatb = Nmat : Nstepb = Nstep
        KindFmoveb = KindFmove
        Mstatb = Mstat

    End Sub

    Private Sub RadioButton1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton1.Click
        If KindFmove > 0 Then
            KindFmove = 0
        End If
    End Sub

    Private Sub RadioButton2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton2.Click
        If KindFmove = 0 Then
            KindFmove = 1
            If Nmat > 1 Then
                Nmat = 1
                TextBox6.Text = LTrim$(Str$(Nmat))
            End If
            If Nstep > 1 Then
                Nstep = 1
            End If
            TextBox7.Text = LTrim$(Str$(Nstep))

        End If
    End Sub

    Private Sub RadioButton3_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton3.Click
        If Mstat > 0 Then
            Mstat = 0
            If Nstep > 1 Then
                Nstep = 1
            End If
            TextBox7.Text = LTrim$(Str$(Nstep))

        End If
    End Sub

    Private Sub RadioButton4_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButton4.Click
        If Mstat = 0 Then
            Mstat = 1
            If KindFmove > 0 Then
                If Nstep > 1 Then
                    Nstep = 1
                End If
                TextBox7.Text = LTrim$(Str$(Nstep))
            End If
        End If

    End Sub

    Private Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Call SpecSet()  '入力ﾃﾞｰﾀ仕様の設定

        If KindFmove > 0 Then
            Dim frm As Form = New Diff3DDat1F()    '流れ計算のﾃﾞｰﾀ仕様入力
            frm.Show()
        Else
            Dim frm As Form = New Diff3DDat1()     '拡散計算のﾃﾞｰﾀ仕様入力
            frm.Show()
        End If
        Me.Close()

    End Sub

    Private Sub Button2_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.Close()

    End Sub

    Private Sub Button3_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim aa$
        Dim ix As Integer

        Call SpecSet()  '入力ﾃﾞｰﾀ仕様の設定

        aa$ = "ファイルへ保存しますか？"
        ix = MsgBox(aa$, 4, "ファイル保存")
        If ix = 6 Then
            InOut = 1
            Dim frm As Form = New AnalDat6() '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
            frm.Show()
            Me.Close()
        End If

    End Sub
End Class